ICU 60.2 60.2

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Types | Public Member Functions | Protected Member Functions
icu::ForwardCharacterIterator Class Referenceabstract

Abstract class that defines an API for forward-only iteration on text objects. More...

`#include <chariter.h>`

Inheritance diagram for icu::ForwardCharacterIterator:

## Public Types
enum | { DONE = 0xffff }
| Value returned by most of ForwardCharacterIterator's functions when the iterator has reached the limits of its iteration. More...

## Public Member Functions
virtual | ~ForwardCharacterIterator ()
| Destructor. More...
virtual UBool | operator== (const ForwardCharacterIterator &that) const =0
| Returns true when both iterators refer to the same character in the same character-storage object. More...
UBool | operator!= (const ForwardCharacterIterator &that) const
| Returns true when the iterators refer to different text-storage objects, or to different characters in the same text-storage object. More...
virtual int32_t | hashCode (void) const =0
| Generates a hash code for this iterator. More...
virtual UClassID | getDynamicClassID (void) const =0
| Returns a UClassID for this ForwardCharacterIterator ("poor man's RTTI"). More...
virtual char16_t | nextPostInc (void)=0
| Gets the current code unit for returning and advances to the next code unit in the iteration range (toward endIndex()). More...
virtual UChar32 | next32PostInc (void)=0
| Gets the current code point for returning and advances to the next code point in the iteration range (toward endIndex()). More...
virtual UBool | hasNext ()=0
| Returns FALSE if there are no more code units or code points at or after the current position in the iteration range. More...
Public Member Functions inherited from icu::UObject
virtual | ~UObject ()
| Destructor. More...

## Protected Member Functions
| ForwardCharacterIterator ()
| Default constructor to be overridden in the implementing class. More...
| ForwardCharacterIterator (const ForwardCharacterIterator &other)
| Copy constructor to be overridden in the implementing class. More...
ForwardCharacterIterator & | operator= (const ForwardCharacterIterator &)
| Assignment operator to be overridden in the implementing class. More...

## Detailed Description

Abstract class that defines an API for forward-only iteration on text objects.

This is a minimal interface for iteration without random access or backwards iteration. It is especially useful for wrapping streams with converters into an object for collation or normalization.

Characters can be accessed in two ways: as code units or as code points. Unicode code points are 21-bit integers and are the scalar values of Unicode characters. ICU uses the type UChar32 for them. Unicode code units are the storage units of a given Unicode/UCS Transformation Format (a character encoding scheme). With UTF-16, all code points can be represented with either one or two code units ("surrogates"). String storage is typically based on code units, while properties of characters are typically determined using code point values. Some processes may be designed to work with sequences of code units, or it may be known that all characters that are important to an algorithm can be represented with single code units. Other processes will need to use the code point access functions.

ForwardCharacterIterator provides nextPostInc() to access a code unit and advance an internal position into the text object, similar to a `return text[position++]`.
It provides next32PostInc() to access a code point and advance an internal position.

next32PostInc() assumes that the current position is that of the beginning of a code point, i.e., of its first code unit. After next32PostInc(), this will be true again. In general, access to code units and code points in the same iteration loop should not be mixed. In UTF-16, if the current position is on a second code unit (Low Surrogate), then only that code unit is returned even by next32PostInc().

For iteration with either function, there are two ways to check for the end of the iteration. When there are no more characters in the text object:

- The hasNext() function returns FALSE.
- nextPostInc() and next32PostInc() return DONE when one attempts to read beyond the end of the text object.

Example:

void function1(ForwardCharacterIterator &it) {
UChar32 c;
while(it.hasNext()) {
c=it.next32PostInc();
// use c
}
}
void function1(ForwardCharacterIterator &it) {
char16_t c;
while((c=it.nextPostInc())!=ForwardCharacterIterator::DONE) {
// use c
}
}

Stable:
  ICU 2.0

Definition at line 91 of file chariter.h.

## Member Enumeration Documentation

anonymous enum

Value returned by most of ForwardCharacterIterator's functions when the iterator has reached the limits of its iteration.

Stable:
  ICU 2.0

Definition at line 98 of file chariter.h.

## Constructor & Destructor Documentation

virtual icu::ForwardCharacterIterator::~ForwardCharacterIterator | ( |  | ) |
| virtual

Destructor.

Stable:
  ICU 2.0

icu::ForwardCharacterIterator::ForwardCharacterIterator | ( |  | ) |
| protected

Default constructor to be overridden in the implementing class.

Stable:
  ICU 2.0

icu::ForwardCharacterIterator::ForwardCharacterIterator | ( | const ForwardCharacterIterator & | other | ) |
| protected

Copy constructor to be overridden in the implementing class.

Stable:
  ICU 2.0

## Member Function Documentation

virtual UClassID icu::ForwardCharacterIterator::getDynamicClassID | ( | void |  | ) | const
| pure virtual

Returns a UClassID for this ForwardCharacterIterator ("poor man's RTTI").

Despite the fact that this function is public, DO NOT CONSIDER IT PART OF CHARACTERITERATOR'S API!

Returns
  a UClassID for this ForwardCharacterIterator

Stable:
  ICU 2.0

Reimplemented from icu::UObject.

Implemented in icu::UCharCharacterIterator, and icu::StringCharacterIterator.

virtual int32_t icu::ForwardCharacterIterator::hashCode | ( | void |  | ) | const
| pure virtual

Generates a hash code for this iterator.

Returns
  the hash code.

Stable:
  ICU 2.0

Implemented in icu::UCharCharacterIterator.

virtual UBool icu::ForwardCharacterIterator::hasNext | ( |  | ) |
| pure virtual

Returns FALSE if there are no more code units or code points at or after the current position in the iteration range.

This is used with nextPostInc() or next32PostInc() in forward iteration.

Returns
  FALSE if there are no more code units or code points at or after the current position in the iteration range.

Stable:
  ICU 2.0

Implemented in icu::UCharCharacterIterator.

virtual UChar32 icu::ForwardCharacterIterator::next32PostInc | ( | void |  | ) |
| pure virtual

Gets the current code point for returning and advances to the next code point in the iteration range (toward endIndex()).

If there are no more code points to return, returns DONE.

Returns
  the current code point.

Stable:
  ICU 2.0

Implemented in icu::UCharCharacterIterator.

virtual char16_t icu::ForwardCharacterIterator::nextPostInc | ( | void |  | ) |
| pure virtual

Gets the current code unit for returning and advances to the next code unit in the iteration range (toward endIndex()).

If there are no more code units to return, returns DONE.

Returns
  the current code unit.

Stable:
  ICU 2.0

Implemented in icu::UCharCharacterIterator.

UBool icu::ForwardCharacterIterator::operator!= | ( | const ForwardCharacterIterator & | that | ) | const
| inline

Returns true when the iterators refer to different text-storage objects, or to different characters in the same text-storage object.

Parameters

  that | The ForwardCharacterIterator to be compared for inequality

Returns
  true when the iterators refer to different text-storage objects, or to different characters in the same text-storage object

Stable:
  ICU 2.0

Definition at line 693 of file chariter.h.

References operator==().

ForwardCharacterIterator& icu::ForwardCharacterIterator::operator= | ( | const ForwardCharacterIterator & |  | ) |
| inline protected

Assignment operator to be overridden in the implementing class.

Stable:
  ICU 2.0

Definition at line 186 of file chariter.h.

virtual UBool icu::ForwardCharacterIterator::operator== | ( | const ForwardCharacterIterator & | that | ) | const
| pure virtual

Returns true when both iterators refer to the same character in the same character-storage object.

Parameters

  that | The ForwardCharacterIterator to be compared for equality

Returns
  true when both iterators refer to the same character in the same character-storage object

Stable:
  ICU 2.0

Implemented in icu::StringCharacterIterator, and icu::UCharCharacterIterator.

Referenced by operator!=().

The documentation for this class was generated from the following file:

- chariter.h